﻿Public Class Form1
    Private Data As Byte()
    Private ReadOnly Latin1 As System.Text.Encoding = System.Text.Encoding.GetEncoding("iso-8859-1")
    Private ReadOnly ListOfUserData As New List(Of String)
    Private Const _256_3 As UInt32 = 16777216UI
    Private Const _256_2 As UInt32 = 65536UI
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Dim path As String = Environment.GetFolderPath(Environment.SpecialFolder.Desktop) + "\Testdatei.txt"
        If Not System.IO.File.Exists(path) Then
            Return
        End If
        Me.Data = System.IO.File.ReadAllBytes(path)
        For i As Integer = 0 To Data.Length - 4 Step 1
            If $"{Convert.ToChar(Data(i))}{Convert.ToChar(Data(i + 1))}{Convert.ToChar(Data(i + 2))}{Convert.ToChar(Data(i + 3))}" = "udta" Then
                Get_UserData(i)
            End If
        Next
        ListBox1.Items.AddRange(ListOfUserData.ToArray())
    End Sub

    Private Sub Get_UserData(i As Integer)
        Dim boxSize0 As UInt32 = Data(i - 4) * _256_3 + Data(i - 3) * _256_2 + Data(i - 2) * 256UI + Data(i - 1)

        For j As Integer = i + 8 To i + CInt(boxSize0) - 8 Step 1 ' nicht 4
            If Latin1.GetString({Data(j), Data(j + 1), Data(j + 2), Data(j + 3)}) = "data" Then
                Dim boxSize1 As UInt32 = Data(j - 4) * _256_3 + Data(j - 3) * _256_2 + Data(j - 2) * 256UI + Data(j - 1)
                If boxSize1 > 100UI Then
                    Me.ListOfUserData.Add("Discarded string")
                    Continue For
                End If
                Dim processedData As Byte() = New Byte(CInt(boxSize1) - 8 - 1) {}
                'Array.Copy(Data, j + 4, processedData, 0, processedData.Length)
                Using ms As New IO.MemoryStream(Me.Data)
                    ms.Seek(j + 4, IO.SeekOrigin.Begin)
                    ms.Read(processedData, 0, processedData.Length)
                End Using
                '                              UTF8 according to the standard
                Dim obtainedString As String = System.Text.Encoding.UTF8.GetString(processedData).TrimStart({Microsoft.VisualBasic.ControlChars.NullChar, Convert.ToChar(1), Convert.ToChar(24)})
                Me.ListOfUserData.Add(obtainedString)
                j += CInt(boxSize1) - 1 ' Do NOT write "Exit For" because these are single items
            End If
        Next
    End Sub
End Class